/*
 *-----------------------------------------------------------------------------
 * File		: OpenSOAPMgr.h
 * Version	: 1.0
 * Project	: OPenSOAP
 * Module	: OpenSOAP Process Manager
 * Date		: 2003/12/02
 * Author	: Conchan
 * Copyright(C) Technoface Corporation
 * http://www.technoface.co.jp/
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#include	"TraceTypes.h"

#include	"TraceMgr.h"
#include	"SharedMgr.h"
#include	"FileMgr.h"

#define		N_OSPROCS		8
#define		U_OSPROCS		8
#define		MAX_TRIES		5

char		*OSRootDir = "/usr/local/opensoap/sbin/";

char		*OSProcess[N_OSPROCS][2] = {
			"srvConfAttrMgr", "",
			"ssmlAttrMgr", "",
			"idManager", "",
			"msgDrvCreator", "",
			"queueManager", "",
			"queueManager", "fwd",
			"spoolManager", "",
			"ttlManager", ""
		};


void		MgrInit(void);
void		MgrSignals(void);
int		MgrMigration(void);
void		MgrRun(int *);
int		MgrForkExec(char **, int *);
void		MgrSignalHandler(int);
void		MgrProcSetStatus(int, bool);
void		MgrProcRestart(int);
void		MgrCleanZombies(void);
void		MgrHalt(int);
int		MgrProcExist(const char *);
bool		MgrVerifyProcPID(int);



